import numpy as np
import csv
import pandas as pd
import matplotlib.pyplot as plt
import scipy.io as io

############# load data and plot signal ############
with open("Data_Signal.csv", 'r') as csvfile:
    reader = csv.reader(csvfile, delimiter = ',')
    data = list(reader)
    data = np.array(data).astype(float)
    
with open("koords.csv", 'r') as csvfile1:
    reader1 = csv.reader(csvfile1, delimiter =';')
    pos = list(reader1)
    pos = np.array(pos)
    
time = np.linspace(0,.2,2000)
time = np.reshape(time,(1,2000))
plt.figure(1)
plt.title('Amplitude of measured Signal')
plt.xlabel('[s]')
plt.ylabel('Amplitude')
plt.plot(time[0,:],data[:,0])
plt.show()


###########################################################
#######  read coordinates from file ###############

with open("coordinates.csv", 'r') as csvfile:
    reader = csv.reader(csvfile, delimiter = ',')
    Coord = list(reader)
    Coord = np.array(Coord).astype(float)
#Coord = np.transpose(Coord)


#######    Read Data from the file    #############

with open("file_kmeans.csv", 'r') as csvfile:
    reader = csv.reader(csvfile, delimiter = ',')
    data = list(reader)
    data = np.array(data).astype(float)
    
data = np.transpose(data)


#######    run Kmeans from sklearn    #############

from sklearn.cluster import KMeans
kmeans = KMeans(n_clusters=5, random_state=0).fit(data)
labels = kmeans.labels_

#######    plot the figure           #############

for i in range(len(Coord)):
    if labels[i]==0:
        plt.scatter(Coord[i,0],Coord[i,1],  s=55, c='r')
    if labels[i]==1:
        plt.scatter(Coord[i,0],Coord[i,1],  s=55, c='g')
    if labels[i]==2:
        plt.scatter(Coord[i,0],Coord[i,1],  s=55, c='b')
    if labels[i]==3:
        plt.scatter(Coord[i,0],Coord[i,1],  s=55, c='c')
    if labels[i]==4:
        plt.scatter(Coord[i,0],Coord[i,1],  s=55, c='y')
    #print i

    
plt.title('Kmeans')
plt.xlabel('[cm]')
plt.ylabel('[cm]')
plt.show()


#######  read coordinates from file #############

with open("Coord1_knn.csv", 'r') as csvfile:
    reader = csv.reader(csvfile, delimiter = ',')
    Coord = list(reader)
    Coord = np.array(Coord)
    
#######    Read Data from the file    #############

with open("file_knn.csv", 'r') as csvfile:
    reader = csv.reader(csvfile, delimiter = ',')
    data = list(reader)
    data = np.array(data).astype(float)
    

# set training data
train = 18
# label 
label = np.zeros((1,44), dtype= int)
label[0,0:train/2] = 1
label[0,train/2:train] = 2

# create normalized training-& testdatasets
f = 0
g = 0
k = 0
# create matrix for train and test data
D1 = np.zeros((2000,9),dtype=float)
D2 = np.zeros((2000,9),dtype=float)
DD = np.zeros((2000,44), dtype=float)
Test = np.zeros((2000,44),dtype=float)
Coord1 = np.zeros((2,44),dtype = float)
CoordNeu = np.zeros((2,44),dtype = float)

##################################################
from numpy import linalg as LA
##################################################

for i in range(train):
    if label[0,i]==1:
        D1[:,f] = data[:,i] / LA.norm(data[:,i])
        Coord1[:,f+g] = Coord[:,i]
        f = f + 1
        
    else:
        D2[:,g] = data[:,i] / LA.norm(data[:,i])
        Coord1[:,f+g] = Coord[:,i]
        g = g + 1
        
DD[:,0:9] = D1
DD[:,9:18] = D2

for j in range(train,62):
    Test[:,k] = data[:,j] / LA.norm(data[:,j])
    CoordNeu[:,k] = Coord[:,j]
    k = k + 1

DD = np.transpose(DD)
label = np.transpose(label)
Test = np.transpose(Test)
label = np.reshape(label,(44,))
#######################################################
from sklearn.neighbors import KNeighborsClassifier
#######################################################
neigh = KNeighborsClassifier(n_neighbors=1)
neigh.fit(DD, label)

y_pred = neigh.predict(Test)
CoordNeu = np.transpose(CoordNeu)
Coord1 = np.transpose(Coord1)
plt.figure()

for j in range(len(Coord1)):
    if label[j]==1:
        plt.scatter(Coord1[j,0],Coord1[j,1], marker = '1',  s=495, c='r')
    if label[j]==2:
        plt.scatter(Coord1[j,0],Coord1[j,1], marker = '2', s=495, c='g')

for i in range(len(CoordNeu)):
    if y_pred[i]==1:
        plt.scatter(CoordNeu[i,0],CoordNeu[i,1], marker = '1', s=35, c='r')
    if y_pred[i]==2:
        plt.scatter(CoordNeu[i,0],CoordNeu[i,1], marker = '2',  s=35, c='g')

    #print i
    
plt.title('KNN')
plt.ylabel('[cm]')
plt.xlabel('[cm]')
plt.show()
    

